/***************************************************************************
                                  Logger.h 
                             -------------------
    begin                : 2001
    copyright            : (C)2001-2003 Multi-Agent Systems Laboratory,
                           University of Science and Technology of China 
                           Zhanxiang Huang, Yang Yang and Xiaoping Chen.
    email                : huangzx@mail.ustc.edu.cn
 ***************************************************************************/

#ifndef _ADVLOGGER_H_
#define _ADVLOGGER_H_

#include <fstream>
#include <string>
#include <cassert>
#include <cstdarg>
#include <cstdio>
#include <iomanip>

using namespace std;

class Logger {
public:
    // ʼLogger
    // lineBuf: ָLoggerлLoggerֵ֧ÿһlogϢ󳤶
    // mark:    logϢǰĸʽ
    Logger(const std::string logfileName, const char mark = '-', int iLineBufLength = 2048);
    Logger(const char* logfileName, const char mark = '-', int iLineBufLength = 2048);
    ~Logger();
    
    
    // 趨logϢǰĸʽ
    void SetFmtMark(const char mark = '-');
    
    // Log һеʽṩprintfĸʽlogļϢģʽ
    // level : ΪĶlogfile㣬levelָ˼logϢǰĸʽĸ
  	void Log(int level,char *fmt,...);

    // ID: ָļlogϢǰlogID
    // level : ΪĶlogfile㣬levelָ˼logϢǰĸʽĸ
  	void Log(int ID,int level,char *fmt,...);

private:
    // ¼logfile
    // string      _logfileName;
    
    // ¼logϢǰĸʽ
    char        _fmtMark;
    
    //лָ
    char* _lineBuf;
    int   _bufLength;
    
    // ¼log
    std::ofstream _os;
   
};

#endif


