/***************************************************************************
                                  Client.h 
                             -------------------
    begin                : 2001
    copyright            : (C)2001-2003 Multi-Agent Systems Laboratory,
                           University of Science and Technology of China 
                           Zhanxiang Huang, Yang Yang and Xiaoping Chen.
    email                : huangzx@mail.ustc.edu.cn 
 ***************************************************************************/

#ifndef _CLIENT_H_
#define _CLIENT_H_

#include <pthread.h>
#include <signal.h>
#include <string>
#include <iostream>
#include <unistd.h>
#include  "Netif.h"
#include  "WECoach.h"
#include "WorldModel.h"

using namespace std;

// ˴ݸNetRecvMsgĲ
struct NetRecvT{
        UDPSocket  *s; 
        WECoach *coach;
        Logger *l;
};


struct InitConnectionT{
        UDPSocket *s;
        bool *initOK;
        string *initMsg;
        string *teamName;
		bool online;
};
    
void *InitConnection(void *arg, bool online);

void *NetRecvMsg(void *arg);

#endif



